# frozen_string_literal: true

require 'spec_helper'

require_relative '../../triage/processor/<%= processor.file_name(with_extension: false) %>'

RSpec.describe Triage::<%= processor.class_name %> do
  include_context 'with event', Triage::IssueEvent do
    let(:event_attrs) do
      {
        object_kind: 'merge_request',
        action: 'open',
        from_gitlab_org?: true,
        noteable_path: '/foo'
      }
    end
  end

  subject { described_class.new(event) }

  include_examples 'registers listeners', [<%= processor.react_to %>]
  include_examples 'applicable on contextual event'

  describe '#applicable?' do
    context 'when event project is not under gitlab-org' do
      before do
        allow(event).to receive(:from_gitlab_org?).and_return(false)
      end

      include_examples 'event is not applicable'
    end
  end

  describe '#documentation' do
    it_behaves_like 'processor documentation is present'
  end

  describe '#process' do
    it 'posts a comment' do
      body = <<~MARKDOWN.chomp
        Hello world!
      MARKDOWN

      expect_comment_request(event: event, body: body) do
        subject.process
      end
    end
  end
end
